Name:          gmaven
Version:       1.4
Release:       6%{?dist}
Summary:       Integration of Groovy into Maven
License:       ASL 2.0
Url:           http://groovy.github.io/gmaven/
# NOTE: moved to github 2012-08-02 https://github.com/groovy/gmaven, 
#       This project is DECEASED
# svn export http://svn.codehaus.org/gmaven/tags/gmaven-1.4
# tar czf gmaven-1.4-src-svn.tar.gz gmaven-1.4
Source0:       %{name}-%{version}-src-svn.tar.gz
# fix build with maven3.x apis
Patch0:        %{name}-%{version}-plugin-maven3-apis-changed.patch
# remove gshell references
Patch1:        %{name}-%{version}-disable-gshell.patch


# BuildRequires: forge-parent
BuildRequires: fusesource-pom
BuildRequires: java-devel

# groovy-all rebundle libraries
BuildRequires: antlr-tool
BuildRequires: apache-commons-cli
BuildRequires: objectweb-asm
# require jline 1.x =< || >= 0.x, multiple package with the same aId:gId
BuildRequires: jline
BuildRequires: mvn(com.thoughtworks.qdox:qdox)
BuildRequires: mvn(commons-lang:commons-lang)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.maven:maven-artifact)
BuildRequires: mvn(org.apache.maven:maven-artifact-manager)
BuildRequires: mvn(org.apache.maven:maven-core)
BuildRequires: mvn(org.apache.maven:maven-monitor)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
BuildRequires: mvn(org.apache.maven:maven-plugin-descriptor)
BuildRequires: mvn(org.apache.maven:maven-project)
BuildRequires: mvn(org.apache.maven:maven-settings)
BuildRequires: mvn(org.apache.maven.reporting:maven-reporting-api)
BuildRequires: mvn(org.apache.maven.reporting:maven-reporting-impl)
BuildRequires: mvn(org.apache.maven.shared:file-management)
BuildRequires: mvn(org.apache.maven.shared:maven-filtering)
BuildRequires: mvn(org.codehaus:codehaus-parent)
BuildRequires: mvn(org.codehaus.groovy:groovy)
BuildRequires: mvn(org.codehaus.plexus:plexus-classworlds)
BuildRequires: mvn(org.codehaus.plexus:plexus-container-default)
BuildRequires: mvn(org.codehaus.plexus:plexus-digest)
BuildRequires: mvn(org.codehaus.plexus:plexus-utils)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.sonatype.gossip:gossip-core)

# test deps
BuildRequires: mvn(junit:junit)

BuildRequires: apache-resource-bundles
BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: maven-dependency-plugin
BuildRequires: maven-invoker-plugin
BuildRequires: maven-plugin-build-helper
BuildRequires: maven-plugin-plugin
BuildRequires: maven-remote-resources-plugin
BuildRequires: maven-surefire-provider-junit4
BuildRequires: maven-surefire-report-plugin
BuildRequires: maven-wagon
BuildRequires: plexus-containers-component-metadata
# require jline 1.x =< || >= 0.x, multiple package with the same aId:gId
Requires:      jline
BuildArch:     noarch

Obsoletes:     %{name}-archetypes < %{version}-%{release}

%description
GMaven provides integration of the Groovy language into Maven.
With GMaven you can:
* Build Groovy Projects
* Execute Groovy Code
* Run Groovy Tools
* Implement Maven Plugins
Advanced:
* Groovy Runtime
* Advanced Configuration

%package -n groovy-maven-plugin
Summary:       Groovy Maven Plugin

%description -n groovy-maven-plugin
Adapts the latest Groovy Maven Plugin to the
legacy 'org.codehaus.mojo:groovy-maven-plugin'
location.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package examples
Summary:       GMaven Examples

%description examples
Provides some example plugins implemented in Groovy.

%prep
%setup -q
%patch0 -p0
%patch1 -p1

# Usupported by XMvn
%pom_disable_module gmaven-archetypes

%pom_disable_module gmaven-testsuite

# Depends on groovy 2.x
%pom_disable_module gmaven-runtime-2.0 gmaven-runtime

# Depends on groovy 1.5.x, 1.6.x, 1.7.x
%pom_disable_module gmaven-runtime-1.5 gmaven-runtime
%pom_disable_module gmaven-runtime-1.6 gmaven-runtime
%pom_disable_module gmaven-runtime-1.7 gmaven-runtime

# Unavailable, unable to built gshell witn latest jline2 package
%pom_remove_dep :gshell-io
%pom_remove_dep :gshell-io gmaven-runtime/gmaven-runtime-support

%pom_xpath_set "pom:project/pom:build/pom:pluginManagement/pom:plugins/pom:plugin[pom:artifactId='maven-javadoc-plugin']/pom:configuration/pom:source" 1.5
%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='maven-compiler-plugin']/pom:configuration/pom:source" 1.5
%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='maven-compiler-plugin']/pom:configuration/pom:target" 1.5
# build problems with our amven-plugin-plugin
%pom_xpath_set "pom:project/pom:packaging" jar gmaven-examples/clean-maven-plugin
%pom_xpath_set "pom:project/pom:packaging" jar gmaven-examples/install-maven-plugin
%pom_xpath_set "pom:project/pom:packaging" jar gmaven-support/filter-plugin

%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='gmaven-plugin']/pom:configuration/pom:providerSelection" 1.8 gmaven-examples
%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='gmaven-plugin']/pom:executions/pom:execution/pom:configuration/pom:providerSelection" \
 1.8 gmaven-mojo

for p in \
 gmaven-runtime/gmaven-runtime-1.8 \
 gmaven-plugin/src/it/compile/compile-1 \
 gmaven-plugin/src/it/compile/compile-4 \
 gmaven-plugin/src/it/compile/generate-stubs-1 \
 gmaven-plugin/src/it/compile/generate-stubs-2 \
 gmaven-plugin/src/it/compile/mixed-compile-1 \
 gmaven-plugin/src/it/compile/mixed-compile-2 \
 gmaven-plugin/src/it/compile/mixed-compile-3 \
 gmaven-plugin/src/it/compile/test-compile-3 \
 gmaven-plugin/src/it/script-libraries/library \
 gmaven-plugin/src/it/plexus-descriptor-1 \
 gmaven-plugin/src/it/compile/test-compile-1 \
 gmaven-plugin/src/it/compile/test-compile-2; do
%pom_xpath_set "pom:project/pom:dependencies/pom:dependency[pom:groupId='org.codehaus.groovy']/pom:artifactId" groovy ${p}
done

for p in gmaven-plugin \
 gmaven-runtime \
 gmaven-runtime/gmaven-runtime-loader; do
%pom_xpath_set "pom:project/pom:dependencies/pom:dependency[pom:groupId='org.sonatype.gossip']/pom:artifactId" gossip-core ${p}
done
%pom_xpath_set "pom:project/pom:dependencyManagement/pom:dependencies/pom:dependency[pom:groupId='org.sonatype.gossip']/pom:artifactId" gossip-core

%pom_remove_dep :gmaven-runtime-1.5
%pom_remove_dep :gmaven-runtime-1.6
%pom_remove_dep :gmaven-runtime-1.7
%pom_remove_dep :gmaven-runtime-2.0
%pom_remove_dep :gmaven-runtime-1.5 gmaven-mojo
%pom_add_dep org.codehaus.gmaven.runtime:gmaven-runtime-1.8:'${project.version}' gmaven-mojo
%pom_remove_dep :gmaven-runtime-1.5 gmaven-plugin
%pom_add_dep org.codehaus.gmaven.runtime:gmaven-runtime-1.8:'${project.version}'::provided gmaven-plugin
%pom_remove_dep :gmaven-runtime-1.6 gmaven-support/filter-plugin
%pom_add_dep org.codehaus.gmaven.runtime:gmaven-runtime-1.8:'${project.version}'::provided gmaven-support/filter-plugin

%pom_xpath_inject "pom:project/pom:modules" "<module>gmaven-runtime-1.8</module>" gmaven-runtime

%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='gmaven-plugin']/pom:configuration/pom:providerSelection" 1.8 gmaven-support/filter-plugin
%pom_xpath_inject "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='gmaven-plugin']" "
<dependencies>
 <dependency>
  <groupId>org.codehaus.gmaven.runtime</groupId>
  <artifactId>gmaven-runtime-1.8</artifactId>
  <version>1.4</version>
  <exclusions>
   <exclusion>
    <groupId>org.codehaus.groovy</groupId>
    <artifactId>groovy</artifactId>
   </exclusion>
  </exclusions>
 </dependency>
 <dependency>
  <groupId>org.codehaus.groovy</groupId>
  <artifactId>groovy</artifactId>
  <version>1.8.9</version>
 </dependency>
 <dependency>
  <groupId>antlr</groupId>
  <artifactId>antlr</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>commons-cli</groupId>
  <artifactId>commons-cli</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>asm</groupId>
  <artifactId>asm-all</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>org.slf4j</groupId>
  <artifactId>slf4j-nop</artifactId>
  <version>any</version>
 </dependency>
</dependencies>" gmaven-support/filter-plugin

for p in groovy-maven-plugin gmaven-mojo-support; do
%pom_xpath_inject "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='gmaven-plugin']" "
<configuration>
 <providerSelection>1.8</providerSelection>
</configuration>
<dependencies>
 <dependency>
  <groupId>org.codehaus.gmaven.runtime</groupId>
  <artifactId>gmaven-runtime-1.8</artifactId>
  <version>1.4</version>
  <exclusions>
   <exclusion>
    <groupId>org.codehaus.groovy</groupId>
    <artifactId>groovy</artifactId>
   </exclusion>
  </exclusions>
 </dependency>
 <dependency>
  <groupId>org.codehaus.groovy</groupId>
  <artifactId>groovy</artifactId>
  <version>1.8.9</version>
 </dependency>
 <dependency>
  <groupId>antlr</groupId>
  <artifactId>antlr</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>commons-cli</groupId>
  <artifactId>commons-cli</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>asm</groupId>
  <artifactId>asm-all</artifactId>
  <version>any</version>
 </dependency>
 <dependency>
  <groupId>org.slf4j</groupId>
  <artifactId>slf4j-nop</artifactId>
  <version>any</version>
 </dependency>
</dependencies>" ${p}
done

# remove wagon-webdav-jackrabbit
%pom_xpath_remove "pom:project/pom:build/pom:extensions"

%pom_xpath_remove "pom:project/pom:prerequisites"
%pom_remove_plugin :maven-enforcer-plugin

%pom_add_dep  org.apache.maven:maven-core gmaven-runtime/gmaven-runtime-loader

for p in gmaven-feature/gmaven-feature-api gmaven-runtime; do
%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:groupId='org.codehaus.plexus']/pom:artifactId" \
 plexus-component-metadata ${p}
%pom_xpath_set "pom:project/pom:build/pom:plugins/pom:plugin[pom:groupId='org.codehaus.plexus']/pom:executions/pom:execution/pom:goals/pom:goal" \
 generate-metadata ${p}
done

%pom_xpath_set "pom:project/pom:build/pom:pluginManagement/pom:plugins/pom:plugin[pom:groupId='org.codehaus.plexus']/pom:artifactId" \
 plexus-component-metadata

# https://jira.codehaus.org/browse/GMAVEN-98
sed -i "s|return new Version(1, 8, 5);|return new Version(1, 8, 9);|" gmaven-runtime/gmaven-runtime-1.8/src/main/java/org/codehaus/gmaven/runtime/v1_8/ProviderImpl.java

%build

%mvn_package "org.codehaus.gmaven.examples:" examples
%mvn_package ":groovy-maven-plugin" groovy-maven-plugin
# runtime profile
%mvn_build -- -Pjava7

%install
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc LICENSE.txt README.txt

%files -n groovy-maven-plugin -f .mfiles-groovy-maven-plugin
%doc LICENSE.txt

%files examples -f .mfiles-examples
%doc LICENSE.txt

%files javadoc -f .mfiles-javadoc
%doc LICENSE.txt

%changelog
* Sun Jul 28 2013 gil cattaneo <puntogil@libero.it> 1.4-6
- Obsolete gmaven-archetypes

* Sun Jul 28 2013 gil cattaneo <puntogil@libero.it> 1.4-5
- switch to XMvn
- adapt to current guideline
- use pom macros
- disable gshell support RHBZ#914056

* Tue Feb 19 2013 gil cattaneo <puntogil@libero.it> 1.4-4
- updated PATCH8

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 1.4-2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Sun Jul 15 2012 gil cattaneo <puntogil@libero.it> 1.4-1
- initial rpm